# Scoreboards
function bentenr:util/scoreboards

# Config
execute if score @s bentenr.config matches 1.. run function bentenr:config/init

# Abilities
execute if entity @s[scores={bentenr.bite=1..}] run function bentenr:abilities/bite
execute unless score @s bentenr.flight matches 0 run function bentenr:abilities/flight
execute if entity @s[scores={bentenr.launch=1..}] run function bentenr:util/launch_player
effect give @s[tag=bentenr.OmniNaut] water_breathing 1 0 true
execute if entity @s[tag=bentenr.OmniNaut,scores={bentenr.alien=0}] run function bentenr:omnitrix/space_armor_tick

# Tags
tag @s[nbt={Inventory:[{Slot:-106b,id:"minecraft:carrot_on_a_stick"}]}] add bentenr.coas_offhand
tag @s[nbt=!{Inventory:[{Slot:-106b,id:"minecraft:carrot_on_a_stick"}]},tag=bentenr.coas_offhand] remove bentenr.coas_offhand
tag @s[nbt={SelectedItem:{id:"minecraft:carrot_on_a_stick"}}] add bentenr.coas_mainhand
tag @s[nbt=!{SelectedItem:{id:"minecraft:carrot_on_a_stick"}},tag=bentenr.coas_mainhand] remove bentenr.coas_mainhand


# Shortcuts
execute if entity @s[scores={bentenr.alien=0,bentenr.shortcut=1..,bentenr.SIS=8}] unless score @s bentenr.shortcu2 = @s bentenr.shortcut run function bentenr:omnitrix/shortcuts/shortcuts



# Antitrix
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=330..342,bentenr.click=1..,bentenr.SIS=8,bentenr.Time=0},predicate=!bentenr:sneaking] run function bentenr:antitrix/cycle
execute if entity @s[tag=!bentenr.noActionbar,tag=bentenr.coas_offhand,scores={bentenr.OCMD=331..342,bentenr.SIS=8}] run function bentenr:antitrix/actionbar
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=331..342,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] if predicate bentenr:can_transform run function bentenr:antitrix/transform
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=331..342,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] unless predicate bentenr:can_transform run tellraw @s {"translate":"bentenr.transformation_fail","color":"dark_red","bold":true}
execute if entity @s[scores={bentenr.alien=..-1},tag=!bentenr.no_timeout] run function bentenr:antitrix/timeout-recharge
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=330..342,bentenr.Time=..-1},tag=!bentenr.no_recharge] run function bentenr:antitrix/timeout-recharge
execute if entity @s[scores={bentenr.Time=..-1}] run function bentenr:antitrix/store_recharge
execute if entity @s[scores={bentenr.alien=..-1}] store result bossbar bentenr:antitrix_time value run scoreboard players get @s bentenr.Time
bossbar set bentenr:antitrix_time players @s[scores={bentenr.alien=..-1},tag=!bentenr.MasterControl]
bossbar set bentenr:antitrix_recharge players @s[scores={bentenr.Time=..-1,bentenr.OCMD=330},tag=!bentenr.MasterControl]




# Omnitrix

#   Cycle

execute if entity @s[tag=bentenr.coas_offhand,tag=bentenr.hasOmniNaut,scores={bentenr.OCMD=296,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] run function bentenr:omnitrix/shortcuts/shortcuts
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.click=1..,bentenr.SIS=8},predicate=!bentenr:sneaking] run function bentenr:omnitrix/cycle
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.SIS=..7}] run function bentenr:omnitrix/reset_cycle
execute if entity @s[tag=!bentenr.noActionbar,tag=bentenr.coas_offhand,scores={bentenr.OCMD=259..269,bentenr.SIS=8}] run function bentenr:omnitrix/actionbar
execute if entity @s[tag=!bentenr.noActionbar,tag=bentenr.coas_offhand,scores={bentenr.OCMD=272..282,bentenr.SIS=8}] run function bentenr:omnitrix/actionbar
execute if entity @s[tag=!bentenr.noActionbar,tag=bentenr.coas_offhand,scores={bentenr.OCMD=285..295,bentenr.SIS=8}] run function bentenr:omnitrix/actionbar
execute if entity @s[tag=!bentenr.noActionbar,tag=bentenr.coas_offhand,scores={bentenr.OCMD=298..308,bentenr.SIS=8}] run function bentenr:omnitrix/actionbar
execute if entity @s[tag=!bentenr.noActionbar,tag=bentenr.coas_offhand,scores={bentenr.OCMD=327..328,bentenr.SIS=8}] run function bentenr:omnitrix/actionbar

# Timeout and Recharge
execute if entity @s[scores={bentenr.alien=1..},tag=!bentenr.no_timeout] run function bentenr:omnitrix/timeout-recharge
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=258},tag=!bentenr.no_recharge] run function bentenr:omnitrix/timeout-recharge
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=271},tag=!bentenr.no_recharge] run function bentenr:omnitrix/timeout-recharge
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=284},tag=!bentenr.no_recharge] run function bentenr:omnitrix/timeout-recharge
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=297},tag=!bentenr.no_recharge] run function bentenr:omnitrix/timeout-recharge


# Transformation
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=259..269,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] if predicate bentenr:can_transform run function bentenr:omnitrix/transform
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=272..282,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] if predicate bentenr:can_transform run function bentenr:omnitrix/transform
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=285..295,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] if predicate bentenr:can_transform run function bentenr:omnitrix/transform
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=298..308,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] if predicate bentenr:can_transform run function bentenr:omnitrix/transform
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=328,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] if predicate bentenr:can_transform run function bentenr:omnitrix/shortcuts/transform
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=259..269,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] unless predicate bentenr:can_transform run tellraw @s {"translate":"bentenr.transformation_fail","color":"dark_red","bold":true}
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=259..269,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] unless predicate bentenr:can_transform run tellraw @s {"translate":"bentenr.transformation_fail","color":"dark_red","bold":true}
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=272..282,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] unless predicate bentenr:can_transform run tellraw @s {"translate":"bentenr.transformation_fail","color":"dark_red","bold":true}
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=298..308,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] unless predicate bentenr:can_transform run tellraw @s {"translate":"bentenr.transformation_fail","color":"dark_red","bold":true}
execute if entity @s[tag=bentenr.coas_offhand,scores={bentenr.OCMD=328,bentenr.click=1..,bentenr.SIS=8},predicate=bentenr:sneaking] unless predicate bentenr:can_transform run tellraw @s {"translate":"bentenr.transformation_fail","color":"dark_red","bold":true}



# Aliens
execute unless score @s bentenr.alien matches 0 run effect give @s invisibility 1 0 true
execute if entity @s[scores={bentenr.Time=..-1,bentenr.OCMD=258}] run function bentenr:omnitrix/store_recharge
execute if entity @s[scores={bentenr.Time=..-1,bentenr.OCMD=271}] run function bentenr:omnitrix/store_recharge
execute if entity @s[scores={bentenr.Time=..-1,bentenr.OCMD=284}] run function bentenr:omnitrix/store_recharge
execute if entity @s[scores={bentenr.Time=..-1,bentenr.OCMD=297}] run function bentenr:omnitrix/store_recharge
execute if entity @s[scores={bentenr.alien=1..}] store result bossbar bentenr:omnitrix_time value run scoreboard players get @s bentenr.Time
bossbar set bentenr:omnitrix_time players @s[scores={bentenr.alien=1..},tag=!bentenr.MasterControl]
bossbar set bentenr:omnitrix_recharge players @s[scores={bentenr.Time=..-1,bentenr.OCMD=258},tag=!bentenr.MasterControl]
bossbar set bentenr:omnitrix_recharge players @s[scores={bentenr.Time=..-1,bentenr.OCMD=271},tag=!bentenr.MasterControl]
bossbar set bentenr:omnitrix_recharge players @s[scores={bentenr.Time=..-1,bentenr.OCMD=284},tag=!bentenr.MasterControl]
bossbar set bentenr:omnitrix_recharge players @s[scores={bentenr.Time=..-1,bentenr.OCMD=297},tag=!bentenr.MasterControl]
tag @s[tag=bentenr.OmniEnhanced] add bentenr.ShockImmune
scoreboard players add @s[tag=bentenr.season4,tag=!bentenr.OmniKix,tag=!bentenr.noOmniKix] bentenr.SIS 1
scoreboard players add @s[tag=bentenr.season4,scores={bentenr.alien=6},tag=bentenr.OmniKix,tag=bentenr.hasOmniNaut] bentenr.SIS 1
scoreboard players remove @s[tag=bentenr.season4,tag=bentenr.OmniKix,scores={bentenr.Time=2..}] bentenr.Time 1
scoreboard players remove @s[tag=bentenr.season4,tag=bentenr.OmniNaut,scores={bentenr.Time=2..}] bentenr.Time 1
execute if entity @s[scores={bentenr.alien=1}] run function bentenr:aliens/heatblast
execute if entity @s[scores={bentenr.alien=2}] run function bentenr:aliens/four_arms
execute if entity @s[scores={bentenr.alien=3},tag=!bentenr.season3,tag=!bentenr.season4] run function bentenr:aliens/grey_matter
execute if entity @s[scores={bentenr.alien=3},tag=!bentenr.season1,tag=!bentenr.season2] run function bentenr:aliens/slapback
execute if entity @s[scores={bentenr.alien=4}] run function bentenr:aliens/cannonbolt
execute if entity @s[scores={bentenr.alien=5}] run function bentenr:aliens/diamondhead
execute if entity @s[scores={bentenr.alien=6},tag=!bentenr.season4] run function bentenr:aliens/stinkfly
execute if entity @s[scores={bentenr.alien=7},tag=!bentenr.season3,tag=!bentenr.season4] run function bentenr:aliens/overflow
execute if entity @s[scores={bentenr.alien=7},tag=!bentenr.season1,tag=!bentenr.season2] run function bentenr:aliens/rath
execute if entity @s[scores={bentenr.alien=8},tag=bentenr.season1] run function bentenr:aliens/upgrade
execute if entity @s[scores={bentenr.alien=9}] run function bentenr:aliens/xlr8
execute if entity @s[scores={bentenr.alien=10},tag=!bentenr.season3,tag=!bentenr.season4] run function bentenr:aliens/wildvine
execute if entity @s[scores={bentenr.alien=10},tag=!bentenr.season1,tag=!bentenr.season2] run function bentenr:aliens/humungousaur
execute if entity @s[scores={bentenr.alien=8},tag=!bentenr.season1] run function bentenr:aliens/shock_rock
execute if entity @s[scores={bentenr.alien=6},tag=bentenr.season4] run function bentenr:aliens/jetray
execute if entity @s[scores={bentenr.alien=11}] run function bentenr:aliens/waybig

execute if entity @s[scores={bentenr.alien=-2}] run function bentenr:aliens/antitrix/quad_smack
execute if entity @s[scores={bentenr.alien=-3}] run function bentenr:aliens/antitrix/dark_matter
execute if entity @s[scores={bentenr.alien=-5}] run function bentenr:aliens/antitrix/crystalfist
execute if entity @s[scores={bentenr.alien=-7}] run function bentenr:aliens/antitrix/undertow
execute if entity @s[scores={bentenr.alien=-11}] run function bentenr:aliens/antitrix/bashmouth


# Omni-Kix
execute if entity @s[tag=bentenr.season4,tag=!bentenr.noOmniKix,tag=!bentenr.OmniKix,tag=!bentenr.OmniNaut,scores={bentenr.alien=1..}] if score @s bentenr.SIS matches 9 run replaceitem entity @s[tag=!bentenr.coas_offhand] weapon.offhand carrot_on_a_stick{CustomModelData:309,display:{Name:'{"text":""}'},HideFlags:63}
execute if entity @s[tag=bentenr.season4] unless score @s bentenr.SIS matches 9 run clear @s carrot_on_a_stick{CustomModelData:309}
title @s[scores={bentenr.SIS=9,bentenr.alien=1..},tag=!bentenr.noOmniKix,tag=!bentenr.OmniNaut,tag=bentenr.season4,tag=!bentenr.OmniKix] actionbar ["",{"translate":"bentenr.omnikix","color":"#68f71a"}]
execute if entity @s[tag=bentenr.season4,tag=!bentenr.noOmniKix,tag=!bentenr.OmniNaut,tag=!bentenr.OmniKix,scores={bentenr.SIS=9,bentenr.click=1..,bentenr.alien=1..}] run function bentenr:omnitrix/omnikix


# Omni-Naut
execute if entity @s[tag=bentenr.season4,tag=bentenr.hasOmniNaut,tag=bentenr.OmniKix,scores={bentenr.alien=6}] if score @s bentenr.SIS matches 9 run replaceitem entity @s[tag=!bentenr.coas_offhand] weapon.offhand carrot_on_a_stick{CustomModelData:326,display:{Name:'{"text":""}'},HideFlags:63}
execute if entity @s[tag=bentenr.season4,tag=bentenr.hasOmniNaut] unless score @s bentenr.SIS matches 9 run clear @s carrot_on_a_stick{CustomModelData:326}
title @s[scores={bentenr.SIS=9,bentenr.alien=6},tag=bentenr.season4,tag=bentenr.hasOmniNaut,tag=bentenr.OmniKix] actionbar ["",{"translate":"bentenr.omninaut","color":"#68f71a"}]
execute if entity @s[tag=bentenr.season4,tag=bentenr.hasOmniNaut,tag=bentenr.OmniKix,scores={bentenr.SIS=9,bentenr.click=1..,bentenr.alien=6}] run function bentenr:omnitrix/omninaut


# Omnitrix Key
execute if entity @s[tag=bentenr.coas_offhand,tag=bentenr.coas_mainhand,scores={bentenr.OCMD=283,bentenr.MCMD=316,bentenr.click=1..},predicate=!bentenr:sneaking] run function bentenr:cheats/to_season_4
execute if entity @s[tag=bentenr.coas_offhand,tag=bentenr.coas_mainhand,scores={bentenr.OCMD=296,bentenr.MCMD=316,bentenr.click=1..},predicate=!bentenr:sneaking] run function bentenr:omnitrix/put_omnikix_key_again
execute if entity @s[tag=bentenr.coas_mainhand,scores={bentenr.MCMD=316,bentenr.click=1..},predicate=bentenr:sneaking] run function bentenr:omnitrix/turn_key
execute if entity @s[tag=bentenr.coas_mainhand,scores={bentenr.MCMD=325,bentenr.click=1..},predicate=bentenr:sneaking] run function bentenr:omnitrix/turn_key_

title @s[tag=!bentenr.noOmniKix,tag=!bentenr.hasOmniNaut,tag=bentenr.coas_offhand,scores={bentenr.OCMD=296},predicate=bentenr:sneaking,x_rotation=90] actionbar ["",{"translate":"bentenr.remove_key","color":"#68f71a"}]
execute if entity @s[tag=!bentenr.noOmniKix,tag=!bentenr.hasOmniNaut,tag=bentenr.coas_offhand,scores={bentenr.OCMD=296,bentenr.click=1..},predicate=bentenr:sneaking,x_rotation=90] run function bentenr:omnitrix/remove_key

execute if entity @s[tag=bentenr.coas_offhand,tag=bentenr.coas_mainhand,scores={bentenr.OCMD=296,bentenr.MCMD=325,bentenr.click=1..}] run function bentenr:cheats/unlock_omninaut

execute if predicate bentenr:inside_omnitrix run function bentenr:omnitrix/inside_omnitrix
execute unless entity @e[type=zombie,tag=bentenr.HighOverride,distance=0..] run bossbar set bentenr:high_override players


#
execute if entity @s[predicate=!bentenr:in_space,scores={bentenr.alien=0}] run scoreboard players set @s bentenr.air 120
execute if entity @s[predicate=bentenr:in_space,tag=!bentenr.OmniNaut,scores={bentenr.air=1..}] run scoreboard players remove @s bentenr.air 1
execute if entity @s[predicate=bentenr:in_space,tag=!bentenr.OmniNaut,scores={bentenr.air=0}] run effect give @s wither 1 1 true
execute if entity @s[predicate=bentenr:using_omninaut_helmet] run tag @s add bentenr.OmniNaut
execute if entity @s[predicate=!bentenr:using_omninaut_helmet,scores={bentenr.alien=0}] run tag @s remove bentenr.OmniNaut
execute if entity @s[predicate=bentenr:in_space] run tp @s ~ 99.25 ~


# Tetramand spear
execute if predicate bentenr:holding_tetramand_spear if score @s bentenr.click matches 1.. run function bentenr:khoros/player_throw_spear
execute if predicate bentenr:holding_tetramand_helmet if score @s bentenr.click matches 1.. run function bentenr:khoros/equip_helmet/equip


scoreboard players set @s bentenr.click 0
scoreboard players set @s bentenr.death 0
scoreboard players operation @s bentenr.shortcu2 = @s bentenr.shortcut
advancement revoke @s only bentenr:ate_poisonous_potato
advancement revoke @s only bentenr:ate_rotten_flesh
advancement revoke @s only bentenr:ate_pufferfish
advancement revoke @s only bentenr:ate_spider_eye
advancement revoke @s[advancements={bentenr:player_hit_entity=true}] only bentenr:player_hit_entity
advancement revoke @s[advancements={bentenr:damage_source/lightning_bolt=true}] only bentenr:damage_source/lightning_bolt
effect clear @s[predicate=!bentenr:using_omninaut_helmet,tag=!bentenr.cancel_no_levitation,nbt={ActiveEffects:[{Id:25b,Amplifier:-1b}]}] levitation